package c.j;

import java.io.PrintWriter;
import java.io.StringWriter;
import java.net.URL;
import java.util.Hashtable;

import bib.*;

import org.xmlrpc.android.XMLRPCClient;
import android.os.AsyncTask;
import android.os.Bundle;
import android.app.Activity;
import android.view.View;
import android.widget.EditText;
import android.widget.TextView;

public class Xa1ClieActivity extends Activity {
    String urlServ = "", pathServ = "";

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_xa1_clie);
    }

    public void onClickExec(View view) {
        urlServ = ((EditText) findViewById(R.id.urlserv)).getText().toString();
        AsyncTask<String, Void, String> task = new AsyncTask<String, Void, String>() {

            @Override
            protected String doInBackground(String... strings) {
                String resp = "";
                XMLRPCClient serviciu = null;
                try {
                    Hashtable<String, String> url = Hurl.hurl(urlServ);
                    String pathServ = url.get("path");
                    if (pathServ.endsWith(".php")) {
                        pathServ = "";
                        serviciu = new XMLRPCClient(new URL("http://"
                                + url.get("host") + ":" + url.get("port") + "/"
                                + url.get("path")));
                    } else {
                        pathServ += ".";
                        serviciu = new XMLRPCClient(new URL("http://"
                                + url.get("host") + ":" + url.get("port")+"/"));
                    }
                    resp += "Client XML-RPC Android: " + serviciu + "\n";
                    String resp1 = (String) serviciu.call(pathServ + "ping");
                    resp += "ping: \t" + resp1 + "\n";
                    resp1 = (String) serviciu.call(pathServ + "upcase",
                            "negru");
                    resp += "upcase: \tnegru = " + resp1 + "\n";
                    Integer resp2 = (Integer) serviciu.call(pathServ + "add",
                            66, 75);
                    resp += "add: \t66 + 75 = " + resp2 + "\n";
                    resp1 = (String) serviciu.call(pathServ + "ping");
                    resp += "ping: \t" + resp1 + "\n";
                    return resp;
                } catch (Exception e) {
                    StringWriter sw = new StringWriter();
                    PrintWriter pw = new PrintWriter(sw);
                    e.printStackTrace(pw);
                    return resp + "ERROR:\n" + sw.toString();
                }

            }

            @Override
            protected void onPostExecute(String res) {
                ((TextView) findViewById(R.id.res)).setText(res);
            }
        };
        task.execute("Execute");
    }
}
