<?php
require_once("xmlrpc.inc"); 
require_once("xmlrpcs.inc");
class Xh1Serv {
    public $pathServ;
    function ping () {
        return new xmlrpcresp(new xmlrpcval(
        "PHP XML-RPC " . $pathServ . " " . $_SERVER["SERVER_NAME"] . " (" .
            gethostbyname($_SERVER["SERVER_NAME"]) . ":" .
            $_SERVER["SERVER_PORT"] . "), " . date("Y.m.d H:i:s"), "string"));
    }
    function upcase ($msg) {
        $s = php_xmlrpc_decode($msg->params[0]);
        return new xmlrpcresp(new xmlrpcval(strtoupper($s), "string"));
    }
    function add ($msg) {
        $a = php_xmlrpc_decode($msg->params[0]);
        $b = php_xmlrpc_decode($msg->params[1]);
        return new xmlrpcresp(new xmlrpcval($a + $b, "int"));
    }
    function start() {
        $serv = new xmlrpc_server(
                array(
                        "ping" =>
                        array(
                                "function" => "Xh1Serv::ping",
                           //"function" => array($this, "ping"), se poate si asa
                                "signature" => array(array("string"))
                        ),
                        "upcase" =>
                        array(
                                "function" => "Xh1Serv::upcase",
                                "signature" => array(array("string", "string"))
                        ),
                        "add" =>
                        array(
                                "function" => "Xh1Serv::add",
                                "signature" => array(array("int", "int", "int"))
                        )
                ), false
        );
        $serv->service();
    }
}
$serviciu = new Xh1Serv();
$serviciu->start();
?>
