using System;
using System.Collections;
using System.Diagnostics;
using Nwc.XmlRpc;
class Xs1Clie {
    public Xs1Clie(String urlServ) {
        Console.WriteLine("Client C# XML-RPC " + urlServ);
        Hashtable url = Hurl.hurl(urlServ);
        String pathServ = (String)url["path"];
        XmlRpcRequest serviciu = new XmlRpcRequest();
        if (pathServ.EndsWith(".php")) { 
            pathServ = "";
            urlServ = "http://"+url["host"]+":"+url["port"]+"/"+url["path"];
        } else {
            pathServ += ".";
            urlServ = "http://"+url["host"]+":"+url["port"];
        }
        serviciu.MethodName = pathServ + "ping";
        XmlRpcResponse response = serviciu.Send(urlServ);
        Console.WriteLine("ping: \t" + response.Value);

        serviciu.MethodName = pathServ + "upcase";
        serviciu.Params.Clear();
        serviciu.Params.Add("negru");
        response = serviciu.Send(urlServ);
        Console.WriteLine("upcase: \tnegru = " + response.Value);

        serviciu.MethodName = pathServ + "add";
        serviciu.Params.Clear();
        serviciu.Params.Add(66);
        serviciu.Params.Add(75);
        response = serviciu.Send(urlServ);
        Console.WriteLine("add: \t66 + 75 = " + response.Value);
        serviciu.Params.Clear();

        serviciu.MethodName = pathServ + "ping";
        response = serviciu.Send(urlServ);
        Console.WriteLine("ping: \t" + response.Value);
    }
    public static void Main(String[] args) {
        if (args.Length > 0) new Xs1Clie(args[0]);
        else new Xs1Clie("http://localhost:1001/Xs1");
    }
}
