using System;
using System.Net;
using Nwc.XmlRpc;
using System.Collections;
class Xs1Serv {
    public int port;
    public String pathServ;
    public String ping() {
        String host = Dns.GetHostName();
        return "C# XML-RPC " + pathServ + " "+ host +
            " (" + Dns.GetHostAddresses(host)[0] + ":" + port + ") " + 
            DateTime.Now;
    }
    public String upcase(String s) {
        return s.ToUpper();
    }
    public int add(int a, int b) {
        return a + b;
    }
    public Xs1Serv(String urlServ) {
        Hashtable url = Hurl.hurl(urlServ);
        pathServ = (String)url["path"];
        port = int.Parse((String)url["port"]);
        XmlRpcServer serviciu = new XmlRpcServer(port);
        serviciu.Add(pathServ, this);
        Console.WriteLine("C# XML-RPC service " + pathServ + 
            " waiting at: " + urlServ);
        serviciu.Start();
    }
    public static void Main(String[] args) {
        if (args.Length > 0) new Xs1Serv(args[0]);
        else new Xs1Serv("http://0.0.0.0:1001/Xs1");
    }
}
