import java.util.*;
import java.net.*;
import org.apache.xmlrpc.client.*;
import bib.*;

public class Xj1Clie {
    public Xj1Clie(String urlServ) throws Exception {
        System.out.println("Client Java XML-RPC " + urlServ);
        Hashtable<String, String> url = Hurl.hurl(urlServ);
        String pathServ = url.get("path");
        XmlRpcClientConfigImpl config = new XmlRpcClientConfigImpl();
        if (pathServ.endsWith(".php")) {
            pathServ = "";
            config.setServerURL(new URL("http://" + url.get("host") + 
                ":" + url.get("port") + "/" + url.get("path")));
        } else {
            pathServ += ".";
            config.setServerURL(new URL("http://" + url.get("host") + 
                ":" + url.get("port")));
        }
        XmlRpcClient serviciu = new XmlRpcClient();
        serviciu.setConfig(config);

        Object[] param = new Object[0];
        String resp1 = (String) serviciu.execute(pathServ + "ping", param);
        System.out.println("ping: \t" + resp1);

        param = new Object[] { "negru" };
        resp1 = (String) serviciu.execute(pathServ + "upcase", param);
        System.out.println("upcase: \tnegru = " + resp1);

        param = new Object[] { new Integer(66), new Integer(75) };
        Integer resp2 = (Integer) serviciu.execute(pathServ + "add", param);
        System.out.println("add: \t66 + 75 = " + resp2);

        param = new Object[0];
        resp1 = (String) serviciu.execute(pathServ + "ping", param);
        System.out.println("ping: \t" + resp1);
    }

    public static void main(String[] args) throws Exception {
        if (args.length > 0)
            new Xj1Clie(args[0]);
        else
            new Xj1Clie("http://localhost:1002/Xj1");
    }
}
