<?php
require_once("xmlrpc.inc");
require_once("Hurl.php");
class Xh1Clie {
    function __construct($urlServ) {
        echo "Client PHP XML-RPC " . $urlServ. "<br/>";
        $url = hurl($urlServ);
        $pathServ = $url["path"];
        if (strpos($pathServ, ".php") == strlen($pathServ) - 4) {
            $pathServ = "";
            $serviciu = new xmlrpc_client("http://".$url["host"].":".$url["port"]."/".$url["path"]);
        } else {
            $pathServ .= ".";
            $serviciu = new xmlrpc_client("http://".$url["host"].":".$url["port"]."/");
        }
        $message = new xmlrpcmsg($pathServ."ping");
        $response = $serviciu->send($message);
        echo "ping: ".php_xmlrpc_decode($response->value())."<br/>";

        $message = new xmlrpcmsg($pathServ."upcase",
                array(new xmlrpcval("negru", "string")));
        $response = $serviciu->send($message);
        $response = php_xmlrpc_decode($response->value());
        echo "upcase: negru = ".$response."<br/>";

        $message = new xmlrpcmsg($pathServ."add",
                array(new xmlrpcval("66", "int"),new xmlrpcval("75", "int")));
        $response = $serviciu->send($message);
        $response = php_xmlrpc_decode($response->value());
        echo "add: 66 + 75 = ".$response."<br/>";

        $message = new xmlrpcmsg($pathServ."ping");
        $response = $serviciu->send($message);
        echo "ping: ".php_xmlrpc_decode($response->value())."<br/>";
    }
}
if (isset($_GET["urlServ"]))
    new Xh1Clie($_GET["urlServ"]);
else
    new Xh1Clie("http://localhost/Xh1Serv.php");
?>
