from SimpleXMLRPCServer import SimpleXMLRPCServer
import sys
import socket
import Hurl
from datetime import datetime
class Xy1Serv:
    pathServ = ""
    port = 0
    def ping(self):
        name = socket.gethostname()
        ip = socket.gethostbyname(name)
        return "Python XML-RPC " + self.pathServ + " " + name + \
            "(" +ip + ":" + `self.port` + "), " + `datetime.now()`
    def upcase(self, s):
        return s.upper()
    def add(self, a, b):
        return a + b
    def __init__(self, urlServ):
        url = Hurl.hurl(urlServ)
        pathServ = url["path"]
        self.port = int(url["port"])
        self.pathServ = pathServ
        serviciu = SimpleXMLRPCServer((url["host"], self.port))
        serviciu.register_function(self.ping, pathServ + ".ping")
        serviciu.register_function(self.upcase, pathServ + ".upcase")
        serviciu.register_function(self.add, pathServ + ".add")
        print "Python XML-RPC service " + pathServ + " waiting at: " + urlServ
        serviciu.serve_forever()
if len(sys.argv) > 1:
    Xy1Serv(sys.argv[1])
else:
    Xy1Serv("http://0.0.0.0:1004/Xy1")
